//////////////////////////////////////////////////////////////////////////////
//
// "Embedded C Programming: Techniques and Applications of C and PIC MCUs"
// by Mark Siegusmund
//
// Exercise 18-1 #1
//
// Asks user to enter the current time in hours, minutes and seconds. Every
// time the push button is pressed, outputs a message with the current time.
//
//////////////////////////////////////////////////////////////////////////////

#include <e3.h>

int count=0;
int32 seconds=0;
int1 print=FALSE;

#int_timer1
void timer1_isr(void) {
   set_timer1(50536+get_timer1());
   count++;
   
   if(count >= 100) {
      count = 0;
      output_toggle(PIN_C6);
      seconds++;
   }
}

#int_ext1
void button1_isr(void) {
   print=TRUE;
}

void display(void) {
   int hours, minutes, secs;
   int32 allSecs;
   
   disable_interrupts(GLOBAL);
   
   allSecs = seconds;
   
   enable_interrupts(GLOBAL);
   
   hours = allSecs / 3600;
   minutes = (allSecs % 3600) / 60;
   secs = allSecs % 60;
   
   printf("\r\n%02u:%02u:%02u (%lu)", hours, minutes, (int)secs, allSecs);
}

void main(void) 
{
   disable_interrupts(INT_TIMER1);
   
   printf("\r\nEnter Hours: ");
   seconds=(int32)get_int_usb()*3600;
   printf("\r\nEnter Minutes: ");
   seconds+=(int32)get_int_usb()*60;
   printf("\r\nEnter Seconds: ");
   seconds+=(int32)get_int_usb();
   
   setup_timer_1(T1_INTERNAL | T1_DIV_BY_8);
   enable_interrupts(INT_EXT1_H2L);
   enable_interrupts(INT_TIMER1);
   enable_interrupts(GLOBAL);
   while(TRUE) {
      if(print) {
         print=FALSE;
         display();
      }
   }
   for(;;);
}
